## cordova-ubuntu-3.4 3.4~pre3.r19build1

=== build/CMakeLists.txt ===
cmake_minimum_required(VERSION 2.8.8)

project(cordova-ubuntu)

set(CMAKE_INCLUDE_CURRENT_DIR ON)
set(CMAKE_AUTOMOC ON)
set(CMAKE_MODULE_PATH ${CMAKE_MODULE_PATH} "${PROJECT_SOURCE_DIR}")

file (STRINGS "VERSION" tmp)
STRING(REGEX MATCH "^[0-9]+\\.[0-9]+" VERSION ${tmp})
STRING(REGEX MATCH "^[0-9]+" MAJOR_VERSION ${tmp})
STRING(REGEX MATCH "[0-9]+$" MINOR_VERSION ${VERSION})

configure_file (
  "${PROJECT_SOURCE_DIR}/qml/main.qml.in"
  "${PROJECT_BINARY_DIR}/main.qml"
)
configure_file (
  "${PROJECT_SOURCE_DIR}/qml/CordovaView.qml.in"
  "${PROJECT_BINARY_DIR}/CordovaView.qml"
)

SET(CMAKE_CXX_FLAGS "-std=c++11 -fno-omit-frame-pointer -O2 -g -Wall -Wextra -DCORDOVA_UBUNTU_VERSION=\\\"${VERSION}\\\" -DCORDOVA_UBUNTU_MAJOR_VERSION=${MAJOR_VERSION} -DCORDOVA_UBUNTU_MINOR_VERSION=${MINOR_VERSION} -I ${PROJECT_SOURCE_DIR}/src")

add_custom_command(OUTPUT ${PROJECT_BINARY_DIR}/qml
  COMMAND mkdir -p ${PROJECT_BINARY_DIR}/qml
  COMMAND ${CMAKE_COMMAND} -E copy ${PROJECT_BINARY_DIR}/main.qml ${PROJECT_BINARY_DIR}/qml
  DEPENDS ${PROJECT_BINARY_DIR}/main.qml
)

file(GLOB tmp Cordovaqt/*)
add_custom_command(
  OUTPUT ${PROJECT_BINARY_DIR}/CordovaUbuntu.${VERSION}
  COMMAND ${CMAKE_COMMAND} -E copy_directory ${CMAKE_SOURCE_DIR}/Cordovaqt ${PROJECT_BINARY_DIR}/CordovaUbuntu.${VERSION}
  COMMAND ${CMAKE_COMMAND} -E copy ${PROJECT_BINARY_DIR}/libcordovaubuntuplugin.so ${PROJECT_BINARY_DIR}/CordovaUbuntu.${VERSION}
  COMMAND ${CMAKE_COMMAND} -E copy ${PROJECT_BINARY_DIR}/CordovaView.qml ${PROJECT_BINARY_DIR}/CordovaUbuntu.${VERSION}
  DEPENDS ${tmp} cordovaubuntuplugin ${PROJECT_BINARY_DIR}/CordovaView.qml
)
file(GLOB tmp xml/*)
add_custom_command(
  OUTPUT ${PROJECT_BINARY_DIR}/xml
  COMMAND ${CMAKE_COMMAND} -E copy_directory ${CMAKE_SOURCE_DIR}/xml ${PROJECT_BINARY_DIR}/xml
  DEPENDS ${tmp} ${PROJECT_SOURCE_DIR}/xml
)
add_custom_target(copy_wwwqmlxml DEPENDS ${PROJECT_BINARY_DIR}/CordovaUbuntu.${VERSION} ${PROJECT_BINARY_DIR}/xml ${PROJECT_BINARY_DIR}/qml)

find_package(Qt5Widgets)
find_package(Qt5Core)

add_executable(cordova-ubuntu
  main.cpp
)
qt5_use_modules(cordova-ubuntu Widgets Quick Xml)
add_dependencies(cordova-ubuntu copy_wwwqmlxml)

ADD_LIBRARY(cordovaubuntuplugin SHARED
  src/cplugin.cpp
  src/cordova.cpp
  src/qmlplugin.cpp

  src/cordova.h
  src/cplugin.h
  src/qmlplugin.h
)
qt5_use_modules(cordovaubuntuplugin Widgets Quick)

#TODO use subprojects
file(GLOB_RECURSE PLUGIN_SOURCES src/plugins/*.cpp)
file(GLOB_RECURSE PLUGIN_HEADERS src/plugins/*.h)

ADD_LIBRARY(coreplugins SHARED
  src/coreplugins.cpp

  ${PLUGIN_SOURCES}
  ${PLUGIN_HEADERS}
)
qt5_use_modules(coreplugins Widgets Location Sensors Feedback SystemInfo Contacts Multimedia Quick MultimediaWidgets)

target_link_libraries(cordova-ubuntu cordovaubuntuplugin)
target_link_libraries(coreplugins cordovaubuntuplugin)

# Qt5's cmake does not export QT_IMPORTS_DIR, lets query qmake on our own for now
get_target_property(QMAKE_EXECUTABLE Qt5::qmake LOCATION)
function(QUERY_QMAKE VAR RESULT)
 exec_program(${QMAKE_EXECUTABLE} ARGS "-query ${VAR}" RETURN_VALUE return_code OUTPUT_VARIABLE output )
 if(NOT return_code)
 file(TO_CMAKE_PATH "${output}" output)
 set(${RESULT} ${output} PARENT_SCOPE)
 endif(NOT return_code)
endfunction(QUERY_QMAKE)
query_qmake(QT_INSTALL_QML QT_IMPORTS_DIR)

install (TARGETS cordova-ubuntu DESTINATION ${CMAKE_INSTALL_PREFIX})
install (TARGETS coreplugins DESTINATION ${CMAKE_INSTALL_PREFIX}/www)
install (FILES ${PROJECT_SOURCE_DIR}/www/cordova.js DESTINATION ${CMAKE_INSTALL_PREFIX}/www/)
install (DIRECTORY ${PROJECT_BINARY_DIR}/qml DESTINATION ${CMAKE_INSTALL_PREFIX})
install (DIRECTORY ${PROJECT_BINARY_DIR}/CordovaUbuntu.${VERSION} DESTINATION ${CMAKE_INSTALL_PREFIX})

=== debian/changelog ===
cordova-ubuntu-3.4 (3.4~pre3.r19build1) trusty; urgency=medium

  * No change rebuild against libqt5core5a.

 -- Dimitri John Ledkov <xnox@ubuntu.com>  Fri, 14 Mar 2014 11:31:48 +0000

cordova-ubuntu-3.4 (3.4~pre3.r19) trusty; urgency=low

  * Releasing 3.4~pre3.r19

 -- David Barth <david.barth@canonical.com>  Thu, 20 Feb 2014 11:48:39 +0100

cordova-ubuntu-3.4 (3.4~pre3.r17ubuntu2) trusty; urgency=low

  * Test build with additional plugins

 -- David Barth <david.barth@canonical.com>  Wed, 19 Feb 2014 17:48:58 +0100

cordova-ubuntu-3.4 (3.4~pre3.r17) trusty; urgency=medium

  [ Alexandre Abreu ]
  * Rename package and paths. (LP: #1281012)

 -- Daniel Holbach <daniel.holbach@ubuntu.com>  Tue, 18 Feb 2014 10:51:24 +0100

cordova-ubuntu-3.4 (3.4~pre3.r16) trusty; urgency=medium

  * Upload r16 of lp:cordova-ubuntu/3.4.

 -- Daniel Holbach <daniel.holbach@ubuntu.com>  Fri, 14 Feb 2014 10:21:43 +0100

cordova-ubuntu-3.4 (3.4~pre3ubuntu1) UNRELEASED; urgency=low

  * Add the full set of platform plugins

 -- David Barth <david.barth@canonical.com>  Fri, 14 Feb 2014 16:17:05 +0100

cordova-ubuntu-3.4 (3.4~pre3) trusty; urgency=low

  * Trusty build

 -- David Barth <david.barth@canonical.com>  Wed, 12 Feb 2014 11:22:25 +0100

cordova-ubuntu-3.4 (3.4~pre3~saucy0) saucy; urgency=low

  * Source package changed to avoid a clash with cordova-ubuntu(-2.8)

 -- David Barth <david.barth@canonical.com>  Wed, 12 Feb 2014 09:55:07 +0000

cordova-ubuntu (3.4~pre1~saucy0) saucy; urgency=low

  * Saucy upload

 -- David Barth <david.barth@canonical.com>  Fri, 07 Feb 2014 10:13:49 -0500

cordova-ubuntu (3.4~pre1) trusty; urgency=low

  * Initial release. (LP: #1279814)

 -- David Barth <david.barth@canonical.com>  Wed, 05 Feb 2014 18:50:34 -0500

=== debian/control ===
Source: cordova-ubuntu-3.4
Section: gnome
Priority: optional
Maintainer: Ubuntu Webapps Team <webapps@lists.ubuntu.com>
Build-Depends: cmake,
               debhelper (>= 9),
               libx11-dev,
               libicu-dev,
               pkg-config,
               qtbase5-dev,
               qtchooser,
               qtdeclarative5-dev,
               qtfeedback5-dev,
               qtlocation5-dev,
               qtmultimedia5-dev,
               qtpim5-dev,
               qtsensors5-dev,
               qtsystems5-dev,
Standards-Version: 3.9.5
Homepage: https://launchpad.net/cordova-ubuntu
# if you don't have have commit access to this branch but would like to upload
# directly to Ubuntu, don't worry: your changes will be merged back into the
# upstream branch
Vcs-Bzr: lp:cordova-ubuntu/3.4

Package: ubuntu-html5-platform-3.4-dev
Section: libdevel
Architecture: any
Depends: ${misc:Depends},
         ${shlibs:Depends},
Description: Cordova Framework for building mobile web apps - development files
 Cordova is a free and open source framework that allows you to create mobile
 apps using standardized web APIs for the platforms you care about.
 .
 This package contains library files that are needed to build applications.
 The libraries are not meant to be installed on the system, but should be
 embedded in a click package.

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-

# to update the source tree:
# create a temporary directory to construct the runtime with the cordova CLI tool
# cordova create runtime
# cd runtime
# cordova platform add ubuntu
# cordova plugin add org.apache.cordova.camera
# cordova plugin add <other plugins>
# ...
# cordova prepare
# then copy back files from the platforms/ubuntu directory

DEB_HOST_MULTIARCH ?= $(shell dpkg-architecture -qDEB_HOST_MULTIARCH)
INSTALL_PREFIX="/usr/share/ubuntu-html5-platform-3.4/${DEB_HOST_MULTIARCH}"
PACKAGE_NAME=ubuntu-html5-platform-3.4-dev

override_dh_auto_configure:
	cd build; cmake -DCMAKE_INSTALL_PREFIX=${INSTALL_PREFIX} \
	                -DCMAKE_VERBOSE_MAKEFILE=ON \
	                -DCMAKE_BUILD_TYPE=RelWithDebInfo

override_dh_install:
	dh_install
	cp -R www debian/${PACKAGE_NAME}/${INSTALL_PREFIX}/; \
	cp -R qml debian/${PACKAGE_NAME}/${INSTALL_PREFIX}/; \
	rm -f debian/${PACKAGE_NAME}/${INSTALL_PREFIX}/cordova-ubuntu

override_dh_strip:

%:
	dh $@ --sourcedirectory=build --fail-missing

## cordova-ubuntu-3.4 3.4~pre3.r19ubuntu1

=== debian/changelog ===
cordova-ubuntu-3.4 (3.4~pre3.r19ubuntu1) utopic; urgency=medium

  * Rename dep package qtsensors5-dev to libqt5sensors5-dev.

 -- Dimitri John Ledkov <xnox@ubuntu.com>  Mon, 23 Jun 2014 11:59:37 +0100

=== debian/control ===
--- 
+++ 
@@ -14,7 +14,7 @@
                qtlocation5-dev,
                qtmultimedia5-dev,
                qtpim5-dev,
-               qtsensors5-dev,
+               libqt5sensors5-dev,
                qtsystems5-dev,
 Standards-Version: 3.9.5
 Homepage: https://launchpad.net/cordova-ubuntu
